% Matlab Exercise M1-1 b)
% Numerical Integration using function 'sum'

clear all

N = 2.^(5:15); % Define the data number

for n=1:length(N)
    
 dx(n) = 2/N(n);% Step size
 x = 0:dx(n):2; % Integration range
 y = 1./(4+x.^2);    % 
 area_y(n) = dx(n)*sum(y); % Integration result
 
end

figure(1)
subplot 211
plot(N,area_y,'-o') % plot the numerical integration result as a function of N
xlabel('Data number, N'), ylabel('Integration Result')
hold on
plot(N,(pi/8)*ones(1,length(N)),'r') % The theoretical value

subplot 212
plot(dx,area_y,'-*') % plot the numerical integration result as a function of dx
xlabel('1/dx'), ylabel('Integration Result')
hold on
plot(dx,(pi/8)*ones(1,length(N)),'r') % The theoretical value