% Chap 1. Exercise M1-3
% Fourier Transform of Rectangular Signal

clear all
close all

to = 4; %[sec] Pulse width

Ts = 0.1*to; % Sampling period
t = (-5*to):Ts:(5*to-Ts); % Define the simulation time 

fs = 1/Ts;    % Sampling frequency
df = fs/length(t); % frequency resolution
f = (-fs/2):df:(fs/2-df); % Simulation frequency range

e_pulse = abs(t)<=(to/2); % Define the rectangular signal with to

%f_pulse1 = to*(sin(pi*to*f)+(f==0))./(pi*to*f+(f==0));
f_pulse1 = to*sinc(to*f); % Theoretical Fourier Transform of e_pulse
f_pulse2 = Ts*fftshift(fft(e_pulse)); % Calculation of Spectrum using fft


figure(1)
subplot(211)
plot(f,abs(f_pulse1),'ro-')
axis([-5/to 5/to 0 max(f_pulse1)])
%xlabel('frequency [Hz]','FontSize',16); 
%title('Theoretical Fourier Transform of \Pi(t/t_o)','FontSize',16)
xlabel('ļ[Hz]','FontSize',16); 
title('̷нĿ  \Pi(t/t_o)  Ǫ ȯ','FontSize',16)


subplot(212)
plot(f,abs(f_pulse2),'bs-')
axis([-5/to 5/to 0 max(f_pulse2)])
%xlabel('frequency [Hz]','FontSize',16); 
%title('Fourier Transform Calculation using fft','FontSize',16)
xlabel('ļ[Hz]','FontSize',16); 
title('fft Լ ̿ \Pi(t/t_o)  Ǫ ȯ ','FontSize',16)


figure(2)
plot(f,20*log10(abs(f_pulse1)/to),'r',f,20*log10(abs(f_pulse2)/to),'-o')
axis([-5/to 5/to -40 3])
%xlabel('frequency [Hz]','FontSize',16); 
%ylabel('20log_1_0|X(f)|','FontSize',16);
%legend('Theoretical','Calculated')
xlabel('ļ[Hz]','FontSize',16); 
ylabel('20log_1_0|X(f)|','FontSize',16);
legend('̷а','fft  ̿ 갪')
